Index: /trunk/anuga_core/source/anuga/file_conversion/test_urs2sww.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/test_urs2sww.py	(revision 7770)
+++ /trunk/anuga_core/source/anuga/file_conversion/test_urs2sww.py	(revision 7770)
@@ -0,0 +1,674 @@
+
+# External modules
+from Scientific.IO.NetCDF import NetCDFFile
+import sys
+import unittest
+import numpy as num
+import copy
+import os
+
+# ANUGA modules
+from anuga.config import netcdf_mode_r, netcdf_mode_w, netcdf_mode_a, \
+                            netcdf_float
+
+from anuga.coordinate_transforms.geo_reference import Geo_reference, \
+     write_NetCDF_georeference
+from anuga.coordinate_transforms.redfearn import redfearn     
+
+from urs2sww import urs2sww
+import urs
+
+from anuga.file.mux import WAVEHEIGHT_MUX_LABEL, EAST_VELOCITY_LABEL, \
+                            NORTH_VELOCITY_LABEL
+
+from anuga.geospatial_data.geospatial_data import ensure_absolute
+from anuga.utilities.numerical_tools import ensure_numeric  
+
+# use helper methods from other unit test
+from anuga.file.test_mux import Test_Mux
+
+
+
+class Test_Dem2Pts(Test_Mux):
+    """ A suite of tests to test urs2sww file conversion functions.
+        These tests are quite coarse-grained: converting a file
+        and checking that its headers and some of its contents
+        are correct.
+    """ 
+
+    def setUp(self):
+        self.verbose = False # change this to output more debug info
+
+  
+    def test_urs_ungridded2swwIII (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 2
+        time_step = 400
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide, origin =(50,23432,4343))
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        
+        #Let's interigate the sww file
+        # Note, the sww info is not gridded.  It is point data.
+        fid = NetCDFFile(sww_file)
+        
+        # Make x and y absolute
+        x = fid.variables['x'][:]
+        y = fid.variables['y'][:]
+        geo_reference = Geo_reference(NetCDFObject=fid)
+        points = geo_reference.get_absolute(map(None, x, y))
+        points = ensure_numeric(points)
+        x = points[:,0]
+        y = points[:,1]
+        
+        #Check that first coordinate is correctly represented       
+        #Work out the UTM coordinates for first point
+        zone, e, n = redfearn(lat_long[0][0], lat_long[0][1]) 
+        assert num.allclose([x[0],y[0]], [e,n])
+
+        #Check the time vector
+        times = fid.variables['time'][:]
+        
+        times_actual = []
+        for i in range(time_step_count):
+            times_actual.append(time_step * i)
+        
+        assert num.allclose(ensure_numeric(times),
+                            ensure_numeric(times_actual))
+        
+        #Check first value
+        stage = fid.variables['stage'][:]
+        xmomentum = fid.variables['xmomentum'][:]
+        ymomentum = fid.variables['ymomentum'][:]
+        elevation = fid.variables['elevation'][:]
+        assert num.allclose(stage[0,0], e +tide)  #Meters
+
+        #Check the momentums - ua
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_ua *(stage+depth)
+        # = n*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_x = n*(e+tide+n)
+        actual_x = xmomentum[0,0]
+        #print "answer_x",answer_x
+        #print "actual_x",actual_x 
+        assert num.allclose(answer_x, actual_x)  #Meters
+        
+        #Check the momentums - va
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_va *(stage+depth)
+        # = e*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_y = -1*e*(e+tide+n)
+        actual_y = ymomentum[0,0]
+        #print "answer_y",answer_y
+        #print "actual_y",actual_y 
+        assert num.allclose(answer_y, actual_y)  #Meters
+
+        # check the stage values, first time step.
+        # These arrays are equal since the Easting values were used as
+        # the stage
+        assert num.allclose(stage[0], x +tide)  #Meters
+        # check the elevation values.
+        # -ve since urs measures depth, sww meshers height,
+        # these arrays are equal since the northing values were used as
+        # the elevation
+        assert num.allclose(-elevation, y)  #Meters
+        
+        fid.close()
+        self.delete_mux(files)
+        os.remove(sww_file)
+
+        
+    def test_urs_ungridded_hole (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-20.5, 114.5],
+                    [-20.6, 114.6],
+                    [-20.5, 115.],
+                    [-20.6, 115.],
+                    [-20.5, 115.5],
+                    [-20.6, 115.4],
+                    
+                    [-21., 114.5],
+                    [-21., 114.6],
+                    [-21., 115.5],
+                    [-21., 115.4],
+                    
+                    [-21.5, 114.5],
+                    [-21.4, 114.6],
+                    [-21.5, 115.],
+                    [-21.4, 115.],
+                    [-21.5, 115.5],
+                    [-21.4, 115.4]
+                    ]
+        time_step_count = 6
+        time_step = 100
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        #Easting:  292110.784  Northing: 7676551.710 
+        #Latitude:   -21  0 ' 0.00000 ''  Longitude: 115  0 ' 0.00000 '' 
+
+        urs2sww(base_name, mean_stage=-240992.0,
+                          hole_points_UTM=[ 292110.784, 7676551.710 ])
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        
+        #Let's interigate the sww file
+        # Note, the sww info is not gridded.  It is point data.
+        fid = NetCDFFile(sww_file)
+        
+        number_of_volumes = fid.variables['volumes']
+        #print "number_of_volumes",len(number_of_volumes) 
+        assert num.allclose(16, len(number_of_volumes))
+        
+        fid.close()
+        self.delete_mux(files)
+        #print "sww_file", sww_file 
+        os.remove(sww_file)
+        
+    def test_urs_ungridded_holeII(self):
+
+        # Check that if using a hole that returns no triangles,
+        # urs_ungridded2sww removes the hole label.
+        
+        lat_long = [[-20.5, 114.5],
+                    [-20.6, 114.6],
+                    [-20.5, 115.5],
+                    [-20.6, 115.4],
+                    
+                    
+                    [-21.5, 114.5],
+                    [-21.4, 114.6],
+                    [-21.5, 115.5],
+                    [-21.4, 115.4]
+                    ]
+        time_step_count = 6
+        time_step = 100
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        #Easting:  292110.784  Northing: 7676551.710 
+        #Latitude:   -21  0 ' 0.00000 ''  Longitude: 115  0 ' 0.00000 '' 
+
+        urs2sww(base_name, mean_stage=-240992.0,
+                          hole_points_UTM=[ 292110.784, 7676551.710 ])
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        fid = NetCDFFile(sww_file)
+        
+        volumes = fid.variables['volumes']
+        #print "number_of_volumes",len(volumes)
+
+        fid.close()
+        os.remove(sww_file)
+        
+        urs2sww(base_name, mean_stage=-240992.0)
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        fid = NetCDFFile(sww_file)
+        
+        volumes_again = fid.variables['volumes']
+        #print "number_of_volumes",len(volumes_again) 
+        assert num.allclose(len(volumes_again),
+                            len(volumes))
+        fid.close()
+        os.remove(sww_file)
+        self.delete_mux(files) 
+        
+    def test_urs_ungridded2sww_mint_maxt (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 6
+        time_step = 100
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide, origin =(50,23432,4343),
+                          mint=101, maxt=500)
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        
+        #Let's interigate the sww file
+        # Note, the sww info is not gridded.  It is point data.
+        fid = NetCDFFile(sww_file)
+        
+        # Make x and y absolute
+        x = fid.variables['x'][:]
+        y = fid.variables['y'][:]
+        geo_reference = Geo_reference(NetCDFObject=fid)
+        points = geo_reference.get_absolute(map(None, x, y))
+        points = ensure_numeric(points)
+        x = points[:,0]
+        y = points[:,1]
+        
+        #Check that first coordinate is correctly represented       
+        #Work out the UTM coordinates for first point
+        zone, e, n = redfearn(lat_long[0][0], lat_long[0][1]) 
+        assert num.allclose([x[0],y[0]], [e,n])
+
+        #Check the time vector
+        times = fid.variables['time'][:]
+        
+        times_actual = [0,100,200,300]
+       
+        assert num.allclose(ensure_numeric(times),
+                            ensure_numeric(times_actual))
+        
+               #Check first value
+        stage = fid.variables['stage'][:]
+        xmomentum = fid.variables['xmomentum'][:]
+        ymomentum = fid.variables['ymomentum'][:]
+        elevation = fid.variables['elevation'][:]
+        assert num.allclose(stage[0,0], e +tide)  #Meters
+
+        #Check the momentums - ua
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_ua *(stage+depth)
+        # = n*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_x = n*(e+tide+n)
+        actual_x = xmomentum[0,0]
+        #print "answer_x",answer_x
+        #print "actual_x",actual_x 
+        assert num.allclose(answer_x, actual_x)  #Meters
+        
+        #Check the momentums - va
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_va *(stage+depth)
+        # = e*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_y = -1*e*(e+tide+n)
+        actual_y = ymomentum[0,0]
+        #print "answer_y",answer_y
+        #print "actual_y",actual_y 
+        assert num.allclose(answer_y, actual_y)  #Meters
+
+        # check the stage values, first time step.
+        # These arrays are equal since the Easting values were used as
+        # the stage
+        assert num.allclose(stage[0], x +tide)  #Meters
+        # check the elevation values.
+        # -ve since urs measures depth, sww meshers height,
+        # these arrays are equal since the northing values were used as
+        # the elevation
+        assert num.allclose(-elevation, y)  #Meters
+        
+        fid.close()
+        self.delete_mux(files)
+        os.remove(sww_file)
+        
+    def test_urs_ungridded2sww_mint_maxtII (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 6
+        time_step = 100
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide, origin =(50,23432,4343),
+                          mint=0, maxt=100000)
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        
+        #Let's interigate the sww file
+        # Note, the sww info is not gridded.  It is point data.
+        fid = NetCDFFile(sww_file)
+        
+        # Make x and y absolute
+        geo_reference = Geo_reference(NetCDFObject=fid)
+        points = geo_reference.get_absolute(map(None, fid.variables['x'][:],
+                                                fid.variables['y'][:]))
+        points = ensure_numeric(points)
+        x = points[:,0]
+        
+        #Check the time vector
+        times = fid.variables['time'][:]
+        
+        times_actual = [0,100,200,300,400,500]
+        assert num.allclose(ensure_numeric(times),
+                            ensure_numeric(times_actual))
+        
+        #Check first value
+        stage = fid.variables['stage'][:]
+        assert num.allclose(stage[0], x +tide)
+        
+        fid.close()
+        self.delete_mux(files)
+        os.remove(sww_file)
+        
+    def test_urs_ungridded2sww_mint_maxtIII (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 6
+        time_step = 100
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        try:
+            urs2sww(base_name, mean_stage=tide,
+                          origin =(50,23432,4343),
+                          mint=301, maxt=399,
+                              verbose=self.verbose)
+        except: 
+            pass
+        else:
+            self.failUnless(0 ==1, 'Bad input did not throw exception error!')
+
+        self.delete_mux(files)
+        
+    def test_urs_ungridded2sww_mint_maxt_bad (self):       
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 6
+        time_step = 100
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        try:
+            urs2sww(base_name, mean_stage=tide,
+                          origin =(50,23432,4343),
+                          mint=301, maxt=301,
+                              verbose=self.verbose)
+        except: 
+            pass
+        else:
+            self.failUnless(0 ==1, 'Bad input did not throw exception error!')
+
+        self.delete_mux(files)
+
+        
+    def test_URS_points_needed_and_urs_ungridded2sww(self):
+        # This doesn't actually check anything
+        #  
+        ll_lat = -21.5
+        ll_long = 114.5
+        grid_spacing = 1./60.
+        lat_amount = 30
+        long_amount = 30
+        time_step_count = 2
+        time_step = 400
+        tide = -200000
+        zone = 50
+
+        boundary_polygon = [[250000,7660000],[280000,7660000],
+                             [280000,7630000],[250000,7630000]]
+        geo=urs.calculate_boundary_points(boundary_polygon, zone,
+                              ll_lat, ll_long, grid_spacing, 
+                              lat_amount, long_amount,
+                              verbose=self.verbose)
+        lat_long = geo.get_data_points(as_lat_long=True)
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide,
+                          verbose=self.verbose)
+        self.delete_mux(files)
+        os.remove( base_name + '.sww')
+    
+    def cache_test_URS_points_needed_and_urs_ungridded2sww(self):
+        
+        ll_lat = -21.5
+        ll_long = 114.5
+        grid_spacing = 1./60.
+        lat_amount = 30
+        long_amount = 30
+        time_step_count = 2
+        time_step = 400
+        tide = -200000
+        zone = 50
+
+        boundary_polygon = [[250000,7660000],[270000,7650000],
+                             [280000,7630000],[250000,7630000]]
+        geo=URS_points_needed(boundary_polygon, zone,
+                              ll_lat, ll_long, grid_spacing, 
+                              lat_amount, long_amount, use_cache=True,
+                              verbose=True)
+        
+    def visual_test_URS_points_needed_and_urs_ungridded2sww(self):
+        
+        ll_lat = -21.5
+        ll_long = 114.5
+        grid_spacing = 1./60.
+        lat_amount = 30
+        long_amount = 30
+        time_step_count = 2
+        time_step = 400
+        tide = -200000
+        zone = 50
+
+        boundary_polygon = [[250000,7660000],[270000,7650000],
+                             [280000,7630000],[250000,7630000]]
+        geo=URS_points_needed(boundary_polygon, zone,
+                              ll_lat, ll_long, grid_spacing, 
+                              lat_amount, long_amount)
+        lat_long = geo.get_data_points(as_lat_long=True)
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide)
+        self.delete_mux(files)
+        os.remove( base_name + '.sww')
+        # extend this so it interpolates onto the boundary.
+        # have it fail if there is NaN
+
+
+  
+    def test_urs_ungridded2swwII (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 2
+        time_step = 400
+        tide = 9000000
+        geo_reference = Geo_reference(50, 3434543,34534543)
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide, origin = geo_reference)
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        
+        #Let's interigate the sww file
+        # Note, the sww info is not gridded.  It is point data.
+        fid = NetCDFFile(sww_file)
+        
+        # Make x and y absolute
+        x = fid.variables['x'][:]
+        y = fid.variables['y'][:]
+        geo_reference = Geo_reference(NetCDFObject=fid)
+        points = geo_reference.get_absolute(map(None, x, y))
+        points = ensure_numeric(points)
+        x = points[:,0]
+        y = points[:,1]
+        
+        #Check that first coordinate is correctly represented       
+        #Work out the UTM coordinates for first point
+        zone, e, n = redfearn(lat_long[0][0], lat_long[0][1]) 
+        assert num.allclose([x[0],y[0]], [e,n])
+
+        #Check the time vector
+        times = fid.variables['time'][:]
+        
+        times_actual = []
+        for i in range(time_step_count):
+            times_actual.append(time_step * i)
+        
+        assert num.allclose(ensure_numeric(times),
+                            ensure_numeric(times_actual))
+        
+        #Check first value
+        stage = fid.variables['stage'][:]
+        xmomentum = fid.variables['xmomentum'][:]
+        ymomentum = fid.variables['ymomentum'][:]
+        elevation = fid.variables['elevation'][:]
+        assert num.allclose(stage[0,0], e +tide)  #Meters
+
+        #Check the momentums - ua
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_ua *(stage+depth)
+        # = n*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_x = n*(e+tide+n)
+        actual_x = xmomentum[0,0]
+        #print "answer_x",answer_x
+        #print "actual_x",actual_x 
+        assert num.allclose(answer_x, actual_x)  #Meters
+        
+        #Check the momentums - va
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_va *(stage+depth)
+        # = e*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_y = -1*e*(e+tide+n)
+        actual_y = ymomentum[0,0]
+        #print "answer_y",answer_y
+        #print "actual_y",actual_y 
+        assert num.allclose(answer_y, actual_y)  #Meters
+
+        # check the stage values, first time step.
+        # These arrays are equal since the Easting values were used as
+        # the stage
+        assert num.allclose(stage[0], x +tide)  #Meters
+        # check the elevation values.
+        # -ve since urs measures depth, sww meshers height,
+        # these arrays are equal since the northing values were used as
+        # the elevation
+        assert num.allclose(-elevation, y)  #Meters
+        
+        fid.close()
+        self.delete_mux(files)
+        os.remove(sww_file)
+
+
+    def test_urs_ungridded2sww (self):
+        
+        #Zone:   50    
+        #Easting:  240992.578  Northing: 7620442.472 
+        #Latitude:   -21  30 ' 0.00000 ''  Longitude: 114  30 ' 0.00000 '' 
+        lat_long = [[-21.5,114.5],[-21,114.5],[-21,115]]
+        time_step_count = 2
+        time_step = 400
+        tide = 9000000
+        base_name, files = self.write_mux(lat_long,
+                                          time_step_count, time_step)
+        urs2sww(base_name, mean_stage=tide,
+                          verbose=self.verbose)
+        
+        # now I want to check the sww file ...
+        sww_file = base_name + '.sww'
+        
+        #Let's interigate the sww file
+        # Note, the sww info is not gridded.  It is point data.
+        fid = NetCDFFile(sww_file)
+        
+        # Make x and y absolute
+        x = fid.variables['x'][:]
+        y = fid.variables['y'][:]
+        geo_reference = Geo_reference(NetCDFObject=fid)
+        points = geo_reference.get_absolute(map(None, x, y))
+        points = ensure_numeric(points)
+        x = points[:,0]
+        y = points[:,1]
+        
+        #Check that first coordinate is correctly represented       
+        #Work out the UTM coordinates for first point
+        zone, e, n = redfearn(lat_long[0][0], lat_long[0][1]) 
+        assert num.allclose([x[0],y[0]], [e,n])
+
+        #Check the time vector
+        times = fid.variables['time'][:]
+        
+        times_actual = []
+        for i in range(time_step_count):
+            times_actual.append(time_step * i)
+        
+        assert num.allclose(ensure_numeric(times),
+                            ensure_numeric(times_actual))
+        
+        #Check first value
+        stage = fid.variables['stage'][:]
+        xmomentum = fid.variables['xmomentum'][:]
+        ymomentum = fid.variables['ymomentum'][:]
+        elevation = fid.variables['elevation'][:]
+        assert num.allclose(stage[0,0], e +tide)  #Meters
+
+
+        #Check the momentums - ua
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_ua *(stage+depth)
+        # = n*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_x = n*(e+tide+n)
+        actual_x = xmomentum[0,0]
+        #print "answer_x",answer_x
+        #print "actual_x",actual_x 
+        assert num.allclose(answer_x, actual_x)  #Meters
+        
+        #Check the momentums - va
+        #momentum = velocity*(stage-elevation)
+        # elevation = - depth
+        #momentum = velocity_va *(stage+depth)
+        # = e*(e+tide+n) based on how I'm writing these files
+        # 
+        answer_y = -1*e*(e+tide+n)
+        actual_y = ymomentum[0,0]
+        #print "answer_y",answer_y
+        #print "actual_y",actual_y 
+        assert num.allclose(answer_y, actual_y)  #Meters
+
+        # check the stage values, first time step.
+        # These arrays are equal since the Easting values were used as
+        # the stage
+        assert num.allclose(stage[0], x +tide)  #Meters
+        # check the elevation values.
+        # -ve since urs measures depth, sww meshers height,
+        # these arrays are equal since the northing values were used as
+        # the elevation
+        assert num.allclose(-elevation, y)  #Meters
+        
+        fid.close()
+        self.delete_mux(files)
+        os.remove(sww_file)
+
+
+#-------------------------------------------------------------
+
+if __name__ == "__main__":
+    suite = unittest.makeSuite(Test_Dem2Pts,'test')
+    runner = unittest.TextTestRunner()
+    runner.run(suite)
Index: /trunk/anuga_core/source/anuga/file_conversion/urs2sww.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/urs2sww.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/file_conversion/urs2sww.py	(revision 7770)
@@ -1,9 +1,27 @@
+import numpy as num
+from Scientific.IO.NetCDF import NetCDFFile
+
+from anuga.file.urs import Read_urs
+
+from anuga.coordinate_transforms.redfearn import redfearn, \
+     convert_from_latlon_to_utm
+
+from anuga.geospatial_data.geospatial_data import ensure_absolute, \
+                                                    Geospatial_data
+
+from mux import WAVEHEIGHT_MUX_LABEL, EAST_VELOCITY_LABEL, \
+                            NORTH_VELOCITY_LABEL
+                            
+from anuga.utilities.numerical_tools import ensure_numeric                            
+
+from anuga.config import netcdf_mode_r, netcdf_mode_w, netcdf_mode_a, \
+                            netcdf_float
+
+from sww_file import Read_sww, Write_sww
+
+
 ################################################################################
 # CONVERTING UNGRIDDED URS DATA TO AN SWW FILE
 ################################################################################
-
-WAVEHEIGHT_MUX_LABEL = '-z-mux'
-EAST_VELOCITY_LABEL =  '-e-mux'
-NORTH_VELOCITY_LABEL =  '-n-mux'
 
 ##
@@ -95,5 +113,5 @@
     mux = {}
     for quantity, file in map(None, quantities, files_in):
-        mux[quantity] = Urs_points(file)
+        mux[quantity] = Read_urs(file)
 
     # Could check that the depth is the same. (hashing)
@@ -143,5 +161,5 @@
     for i in range(a_mux.time_step_count):
         mux_times.append(a_mux.time_step * i)
-    (mux_times_start_i, mux_times_fin_i) = mux2sww_time(mux_times, mint, maxt)
+    (mux_times_start_i, mux_times_fin_i) = read_time_from_mux(mux_times, mint, maxt)
     times = mux_times[mux_times_start_i:mux_times_fin_i]
 
@@ -209,2 +227,24 @@
 
     # Do some conversions while writing the sww file
+
+
+def read_time_from_mux(mux_times, mint, maxt):
+    """
+        Read a list of mux times.
+        Return start and finish times which lie within the passed time period.
+    """
+
+    if mint == None:
+        mux_times_start_i = 0
+    else:
+        mux_times_start_i = num.searchsorted(mux_times, mint)
+
+    if maxt == None:
+        mux_times_fin_i = len(mux_times)
+    else:
+        maxt += 0.5 # so if you specify a time where there is
+                    # data that time will be included
+        mux_times_fin_i = num.searchsorted(mux_times, maxt)
+
+    return mux_times_start_i, mux_times_fin_i
+
Index: /trunk/anuga_core/source/anuga/file_conversion/urs2txt.py
===================================================================
--- /trunk/anuga_core/source/anuga/file_conversion/urs2txt.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/file_conversion/urs2txt.py	(revision 7770)
@@ -1,3 +1,3 @@
-
+from anuga.file.urs import Read_urs
 
 ##
@@ -20,5 +20,5 @@
     mux = {}
     for quantity, file in map(None, quantities, files_in):
-        mux[quantity] = Urs_points(file)
+        mux[quantity] = Read_urs(file)
 
     # Could check that the depth is the same. (hashing)
Index: /trunk/anuga_core/source/anuga/pmesh/mesh_interface.py
===================================================================
--- /trunk/anuga_core/source/anuga/pmesh/mesh_interface.py	(revision 7769)
+++ /trunk/anuga_core/source/anuga/pmesh/mesh_interface.py	(revision 7770)
@@ -26,4 +26,5 @@
                              interior_regions=None,
                              interior_holes=None,
+                             hole_tags=None,
                              poly_geo_reference=None,
                              mesh_geo_reference=None,
@@ -53,5 +54,7 @@
     throw an error
     
-    Interior_holes is a list of ploygons for each hole.
+    Interior_holes is a list of polygons for each hole.
+    hole_tags is an optional list of boundary tags for the holes, see
+                boundary_tags parameter.
 
     This function does not allow segments to share points - use underlying
@@ -92,4 +95,5 @@
               'interior_regions': interior_regions,
               'interior_holes': interior_holes,
+              'hole_tags': hole_tags,
               'poly_geo_reference': poly_geo_reference,
               'mesh_geo_reference': mesh_geo_reference,
@@ -127,4 +131,5 @@
                               interior_regions=None,
                               interior_holes=None,
+                              hole_tags=None,
                               poly_geo_reference=None,
                               mesh_geo_reference=None,
@@ -311,4 +316,5 @@
         for polygon in interior_holes:
             m.add_hole_from_polygon(polygon,
+                                    segment_tags=hole_tags,
                                     geo_reference=poly_geo_reference)
        
